﻿Imports System.Windows.Data
Imports Infragistics.Windows.DataPresenter
Imports System.Windows

Public Class UserControl1
  Public Sub New()
    ' This call is required by the designer.
    InitializeComponent()
    Dim dicValues As New Dictionary(Of Integer, String)
    dicValues.Add(1, 101)
    dicValues.Add(2, 100)
    dicValues.Add(3, 101)
    dicValues.Add(4, 101)
    dicValues.Add(5, 101)
    dgrData.DataSource = dicValues

    ' Add any initialization after the InitializeComponent() call.

  End Sub

  Private Sub dgrData_FieldLayoutInitialized(ByVal sender As System.Object, ByVal e As Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs) Handles dgrData.FieldLayoutInitialized

    Dim oValueField As New Field
    oValueField.Name = "Value"
    Dim oBinding As New Binding("Value")
    oBinding.Converter = New MyConverter()
    oBinding.RelativeSource = New RelativeSource(RelativeSourceMode.Self)
    Dim oStyle As New Style(GetType(CellValuePresenter))
    oStyle.Setters.Add(New Setter(CellValuePresenter.ForegroundProperty, oBinding))
    oValueField.Settings.CellValuePresenterStyle = oStyle
    e.FieldLayout.Fields.Add(oValueField)

    e.FieldLayout.FieldSettings.AllowEdit = True

  End Sub
End Class

Public Class MyConverter
  Implements System.Windows.Data.IValueConverter
  Public Function Convert(value As Object, targetType As System.Type, parameter As Object, culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.Convert
    Dim dblValue As Double = Nothing
    If Double.TryParse(value, dblValue) AndAlso dblValue > 100.0 Then
      Return Brushes.Red
    Else
      Return Brushes.Green
    End If
  End Function

  Public Function ConvertBack(value As Object, targetType As System.Type, parameter As Object, culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.ConvertBack
    Return Binding.DoNothing()
  End Function
End Class
